Loading...
Searching...
No Matches
crypto_compat.h File Reference

PSA cryptography module: Backward compatibility aliases. More...

This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | PSA_KEY_HANDLE_INIT MBEDTLS_SVC_KEY_ID_INIT
#define | PSA_DH_FAMILY_CUSTOM ((psa_dh_family_t) MBEDTLS_DEPRECATED_NUMERIC_CONSTANT(0x7e))
#define | PSA_KEY_DOMAIN_PARAMETERS_SIZE(key_type, key_bits)

## Typedefs

typedef mbedtls_svc_key_id_t | psa_key_handle_t

## Functions

static int | psa_key_handle_is_null (psa_key_handle_t handle)
psa_status_t | psa_open_key (mbedtls_svc_key_id_t key, psa_key_handle_t *handle)
psa_status_t | psa_close_key (psa_key_handle_t handle)
static psa_status_t MBEDTLS_DEPRECATED | psa_set_key_domain_parameters (psa_key_attributes_t *attributes, psa_key_type_t type, const uint8_t *data, size_t data_length)
| Set domain parameters for a key.
static psa_status_t MBEDTLS_DEPRECATED | psa_get_key_domain_parameters (const psa_key_attributes_t *attributes, uint8_t *data, size_t data_size, size_t *data_length)
| Get domain parameters for a key.

## Detailed Description

PSA cryptography module: Backward compatibility aliases.

This header declares alternative names for macro and functions. New application code should not use these names. These names may be removed in a future version of Mbed TLS.

Note
  This file may not be included directly. Applications must include psa/crypto.h.

Definition in file crypto_compat.h.

## Macro Definition Documentation

## PSA_KEY_HANDLE_INIT

#define PSA_KEY_HANDLE_INIT MBEDTLS_SVC_KEY_ID_INIT

Definition at line 33 of file crypto_compat.h.

## Typedef Documentation

## psa_key_handle_t

typedef mbedtls_svc_key_id_t psa_key_handle_t

Definition at line 31 of file crypto_compat.h.

## Function Documentation

## psa_close_key()

psa_status_t psa_close_key | ( | psa_key_handle_t | handle | ) |

Close a key handle.

If the handle designates a volatile key, this will destroy the key material and free all associated resources, just like psa_destroy_key().

If this is the last open handle to a persistent key, then closing the handle will free all resources associated with the key in volatile memory. The key data in persistent storage is not affected and can be opened again later with a call to psa_open_key().

Closing the key handle makes the handle invalid, and the key handle must not be used again by the application.

Note
  This API is not part of the PSA Cryptography API Release 1.0.0 specification. It was defined in the 1.0 Beta 3 version of the specification but was removed in the 1.0.0 released version. This API is kept for the time being to not break applications relying on it. It is not deprecated yet but will be in the near future.
  If the key handle was used to set up an active :ref:`multipart operation <multipart-operations>`, then closing the key handle can cause the multipart operation to fail. Applications should maintain the key handle until after the multipart operation has finished.

Parameters

  handle | The key handle to close. If this is `0`, do nothing and return `PSA_SUCCESS`.

Return values

  PSA_SUCCESS | `handle` was a valid handle or `0`. It is now closed.
  PSA_ERROR_INVALID_HANDLE | `handle` is not a valid handle nor `0`.
  PSA_ERROR_COMMUNICATION_FAILURE |
  PSA_ERROR_CORRUPTION_DETECTED |
  PSA_ERROR_BAD_STATE | The library has not been previously initialized by psa_crypto_init(). It is implementation-dependent whether a failure to initialize results in this error code.

## psa_key_handle_is_null()

int psa_key_handle_is_null | ( | psa_key_handle_t | handle | ) |

inline static

Check whether a handle is null.

Parameters

  handle | Handle

Returns
  Non-zero if the handle is null, zero otherwise.

Definition at line 41 of file crypto_compat.h.

References mbedtls_svc_key_id_is_null().

## psa_open_key()

psa_status_t psa_open_key | ( | mbedtls_svc_key_id_t | key,
|  | psa_key_handle_t * | handle )

Open a handle to an existing persistent key.

Open a handle to a persistent key. A key is persistent if it was created with a lifetime other than PSA_KEY_LIFETIME_VOLATILE. A persistent key always has a nonzero key identifier, set with psa_set_key_id() when creating the key. Implementations may provide additional pre-provisioned keys that can be opened with psa_open_key(). Such keys have an application key identifier in the vendor range, as documented in the description of psa_key_id_t.

The application must eventually close the handle with psa_close_key() or psa_destroy_key() to release associated resources. If the application dies without calling one of these functions, the implementation should perform the equivalent of a call to psa_close_key().

Some implementations permit an application to open the same key multiple times. If this is successful, each call to psa_open_key() will return a different key handle.

Note
  This API is not part of the PSA Cryptography API Release 1.0.0 specification. It was defined in the 1.0 Beta 3 version of the specification but was removed in the 1.0.0 released version. This API is kept for the time being to not break applications relying on it. It is not deprecated yet but will be in the near future.
  Applications that rely on opening a key multiple times will not be portable to implementations that only permit a single key handle to be opened. See also :ref:`key-handles`.

Parameters

  | key | The persistent identifier of the key.
  [out] | handle | On success, a handle to the key.

Return values

  PSA_SUCCESS | Success. The application can now use the value of *handle to access the key.
  PSA_ERROR_INSUFFICIENT_MEMORY | The implementation does not have sufficient resources to open the key. This can be due to reaching an implementation limit on the number of open keys, the number of open key handles, or available memory.
  PSA_ERROR_DOES_NOT_EXIST | There is no persistent key with key identifier `key`.
  PSA_ERROR_INVALID_ARGUMENT | `key` is not a valid persistent key identifier.
  PSA_ERROR_NOT_PERMITTED | The specified key exists, but the application does not have the permission to access it. Note that this specification does not define any way to create such a key, but it may be possible through implementation-specific means.
  PSA_ERROR_COMMUNICATION_FAILURE |
  PSA_ERROR_CORRUPTION_DETECTED |
  PSA_ERROR_STORAGE_FAILURE |
  PSA_ERROR_DATA_INVALID |
  PSA_ERROR_DATA_CORRUPT |
  PSA_ERROR_BAD_STATE | The library has not been previously initialized by psa_crypto_init(). It is implementation-dependent whether a failure to initialize results in this error code.